"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _handler = require("@webiny/handler");
var _set = _interopRequireDefault(require("lodash/set"));
var _oEmbed = require("../graphql/pages/oEmbed");
var _useElementVariables = require("./useElementVariables");
const supportedTypes = ["soundcloud", "vimeo", "youtube", "pinterest", "twitter"];
var _default = new _handler.ContextPlugin(context => {
  context.pageBuilder.addPageElementProcessor(async ({
    block,
    element
  }) => {
    if (!supportedTypes.includes(element.type)) {
      return;
    }
    const variables = (0, _useElementVariables.useElementVariables)(block, element);
    const value = variables?.length > 0 ? variables[0].value : null;
    if (value !== undefined && value !== null) {
      (0, _set.default)(element, "data.source.url", value);
      const provider = (0, _oEmbed.findProvider)(value);
      if (provider) {
        try {
          const oembed = await (0, _oEmbed.fetchEmbed)({
            url: value
          }, provider);
          (0, _set.default)(element, "data.oembed", oembed);
        } catch {}
      }
    }
  });
});
exports.default = _default;

//# sourceMappingURL=embed.js.map